package dk.aau.cs.model.tapn.Colored.Expressions;

import dk.aau.cs.model.tapn.Colored.Multiset;
import dk.aau.cs.model.tapn.Colored.Variable;

import java.util.Set;
import java.util.Vector;

public class NumberOfExpression extends ArcExpression {
    private Integer number;
    private Vector<ColorExpression> color;
    private AllExpression all;

    public NumberOfExpression(Integer number, Vector<ColorExpression> color, AllExpression all) {
        this.number = number;
        this.color = color;
        this.all = all;
    }
    //Missing implementation for evaluation - might not be needed
    public Multiset eval(ExpressionContext context) {
        return null;
    }

    public void expressionType() {

    }

    public Integer weight() {
        if (all == null) {
            return number * color.size();
        }
        else {
            return number * all.size();
        }
    }

    public void getVariables(Set<Variable> variables) {
        if (all == null) {
            return;
        }
        for (ColorExpression element: color) {
            element.getVariables(variables);
        }
    }

    public String toString() {
        if (all == null) {
            return number.toString() + "'(" + all.toString() + ")";
        }
        String res = number.toString() + "'(" + color.get(0).toString() + ")";
        for (int i = 1; i < color.size(); ++i) {
            res += " + ";
            res += number.toString() + "'(" + color.get(i).toString() + ")";
        }
        return res;
    }

}
